icmp_recv:
  cmp byte ptr [ip_data], 8
  jne icmp_recv_done

  ;mov si, offset strisecho
  ;call printmsg

  mov di, offset ip_send_data
  mov si, offset ip_data
  mov cx, [ip_tot_len]
  rep movsb
  xor ax, ax ;also add zero-padding for checksum calc
  mov cx, 2
  rep stosw ;in case payload byte length is odd

  mov [ip_send_data], 0 ;echo reply ICMP type

  mov ax, [ip_tot_len]
  mov [ip_send_total_len], ax

  ;mov ax, [ip_ident]
  ;mov [ip_send_ident], ax

  mov si, offset recv_src
  mov di, offset pkt_dest
  mov cx, 3
  rep movsw

  mov si, offset ip_src
  mov di, offset ip_send_dest
  mov cx, 2
  rep movsw

  mov ax, 0 ;clear ICMP checksum value before calculating
  mov di, offset ip_send_data+2
  stosw

  xor bx, bx ;BX will be our accumulator when calculating checksum
  mov si, offset ip_send_data
  mov cx, [ip_data_len]
  shr cx, 1
  clc
  loop_calc_icmp_chksum:
	lodsw
	xchg ah, al ;byteswap it
	adc bx, ax
	loop loop_calc_icmp_chksum
  adc bx, 0 ;account for any left over carry bit
  not bx ;one's complement the accumulated value
  xchg bh, bl ;byteswap checksum to network byte order

  mov byte ptr [ip_send_protocol], 1 ;protocol is ICMP of course

  mov [ip_send_data+2], bx ;insert checksum into IP header
  call ip_send

icmp_recv_done:
  ret

strisecho db '[DEBUG] It is an echo request!', 13, 10, 0
