nest MACRO stacksize
  push bp
  mov bp, sp
  sub sp, stacksize
ENDM

denest MACRO
  mov sp, bp
  pop bp
ENDM

pushall MACRO
  pushf
  push ax
  push cx
  push dx
  push bx
  push bp
  push si
  push di
  push ds
  push es
  push ss
ENDM

popall MACRO
  pop ss
  pop es
  pop ds
  pop di
  pop si
  pop bp
  pop bx
  pop dx
  pop cx
  pop ax
  popf
ENDM

inc_ack MACRO
  push di
  mov di, cs:[tcp_cur_handle]
  shl di, 1
  shl di, 1
  add di, offset tcp_ack

  add byte ptr cs:[di+3], 1
  adc byte ptr cs:[di+2], 0
  adc byte ptr cs:[di+1], 0
  adc byte ptr cs:[di], 0
  pop di
ENDM

inc_seq MACRO
  push di
  mov di, cs:[tcp_cur_handle]
  shl di, 1
  shl di, 1
  add di, offset tcp_seq

  add byte ptr cs:[di+3], 1
  adc byte ptr cs:[di+2], 0
  adc byte ptr cs:[di+1], 0
  adc byte ptr cs:[di], 0
  pop di
ENDM
