DECLARE SUB modval (valname AS STRING, BYVAL valpos AS INTEGER)
DIM SHARED ip(3)  AS INTEGER

PRINT "MiniTCP IP configuration tool v0.11.8.5"

modval "IP", 4
modval "subnet mask", 8
modval "gateway", 12

SUB modval (valname AS STRING, BYVAL valpos AS INTEGER)
PRINT
PRINT "Current " + valname$ + " setting: ";
OPEN "minitcp.com" FOR BINARY AS #1
SEEK #1, valpos
a$ = SPACE$(1)
FOR n = 0 TO 3
  GET #1, , a$
  ip(n) = ASC(a$)
  PRINT MID$(STR$(ip(n)), 2);
  IF n < 3 THEN PRINT ".";
NEXT n
PRINT
PRINT "New " + valname + ", or blank to keep current: ";
LINE INPUT "", newip$
IF LEN(newip$) = 0 THEN CLOSE #1: EXIT SUB
FOR n = 0 TO 3
  IF n < 3 THEN
    xp = INSTR(1, newip$, ".")
    IF xp < 1 THEN PRINT "Invalid IP format!": CLOSE #1: END
  ELSE
    xp = LEN(newip$) + 1
  END IF
  ip(n) = VAL(LEFT$(newip$, xp - 1)) AND 255
  newip$ = MID$(newip$, xp + 1)
  PRINT MID$(STR$(ip(n)), 2);
  IF n < 3 THEN PRINT ".";
NEXT n
PRINT
PRINT "Modifying MINITCP.COM with new " + valname$ + "..."
SEEK #1, valpos
FOR n = 0 TO 3
  a$ = CHR$(ip(n))
  PUT #1, , a$
NEXT n
CLOSE #1
END SUB

