;enter printmsg with ASCII-Z string pointed to by SI (string must be in CS)
printmsg:
  pushall
  mov ax, cs
  mov ds, ax
  cld
  print_next:
	mov ah, 0Eh
    lodsb
    cmp al, 0
    jz print_done
    int 10h
    jmp print_next
  print_done:
	popall
    ret

crlf:
  pushf
  push ax
  mov ax, 0E0Dh
  int 10h
  mov ax, 0E0Ah
  int 10h
  pop ax
  popf
  ret

strhex   db '0000', 0
hextable db '0123456789ABCDEF'
print_hex:
  pushall
  std
  mov ax, cs
  mov ds, ax
  mov es, ax
  mov bx, offset hextable
  mov di, offset strhex
  add di, 3
  mov cx, 4
  nexthex:
	mov ax, dx
	and ax, 0Fh
	shr dx, 1
	shr dx, 1
	shr dx, 1
	shr dx, 1
	xlat
	stosb
	loop nexthex
  cld
  mov si, offset strhex
  mov cx, 4
  printnexthex:
	mov ah, 0Eh
	lodsb
	int 10h
	loop printnexthex
  popall
  ret

print_hex_8:
  pushall
  std
  mov ax, cs
  mov ds, ax
  mov es, ax
  mov bx, offset hextable
  mov di, offset strhex
  inc di
  mov cx, 2
  nexthex_8:
	mov ax, dx
	and ax, 0Fh
	shr dx, 1
	shr dx, 1
	shr dx, 1
	shr dx, 1
	xlat
	stosb
	loop nexthex_8
  cld
  mov si, offset strhex
  mov cx, 2
  printnexthex_8:
	mov ah, 0Eh
	lodsb
	int 10h
	loop printnexthex_8
  popall
  ret

val_array db 10 dup (0)
orig_val  dw 0
non_zero  db 0
print_dec: ;enter with up to a 16-bit value in AX
  pushall
  cli
  std
  mov bx, cs
  mov es, bx
  mov ds, bx
  mov di, offset val_array
  add di, 9

  mov cs:[orig_val], ax
  mov cx, 10
  mov bx, 10
  conv_to_array:
	xor dx, dx
	mov ax, cs:[orig_val]
	div bx
	mov cs:[orig_val], ax
	mov al, dl
	stosb
	loop conv_to_array

  cld
  mov si, offset val_array
  mov cx, 10
  mov cs:[non_zero], 0
  array_to_ascii:
	lodsb
	cmp cx, 1
	je skip_zero_check ;if the full value was zero, we still want one shown
	cmp cs:[non_zero], 1
	je skip_zero_check
	cmp al, 0
	jz skip_zero
	mov cs:[non_zero], 1
  skip_zero_check:
	add al, 30h
	mov ah, 0Eh
	int 10h
	skip_zero:
	  loop array_to_ascii
  popall
  ret

printmac: ;enter this with near pointer to 6-byte MAC field in SI
  pushall
  mov ax, cs
  mov ds, ax
  cld
  mov cx, 5
  printmacbyte:
	lodsb
	xor dx, dx
	mov dl, al
	call print_hex_8
	mov ah, 0Eh
	mov al, ':'
	int 10h
	loop printmacbyte
  lodsb
  xor dx, dx
  mov dl, al
  call print_hex_8
printmacdone:
  popall
  ret

printip: ;enter this with near pointer to 4-byte IP field in SI
  pushall
  mov ax, cs
  mov ds, ax
  cld
  mov cx, 3
  printipbyte:
	lodsb
	xor ah, ah
	call print_dec
	mov ah, 0Eh
	mov al, '.'
	int 10h
	loop printipbyte
  lodsb
  xor ah, ah
  call print_dec
printipdone:
  popall
  ret
